Package: BlockCov
Type: Package
Title: Estimation of Large Block Covariance Matrices
Version: 0.1.1
Author: M. Perrot-Dock\`es, C. Lévy-Leduc
Maintainer: Marie Perrot-Dockès <marie.perrocks@gmail.com>
Description: Computation of large covariance matrices having a block structure up to a permutation of their columns and rows 
    from a small number of samples with respect to the dimension of the matrix.
 The method is described in the paper Perrot-Dockès et al. (2019) <arXiv:1806.10093>.
License: GPL (>= 2)
Encoding: UTF-8
LazyData: true
RoxygenNote: 6.1.1
VignetteBuilder: knitr
Imports: Matrix, stats, Rdpack, BBmisc, dplyr, tibble, magrittr, rlang
Suggests: knitr
RdMacros: Rdpack
NeedsCompilation: no
Packaged: 2019-04-13 18:32:17 UTC; perrot-dockes
Repository: CRAN
Date/Publication: 2019-04-13 22:55:38 UTC

#' This function computes an estimator of the covariance matrix and the square root of its inverse and permutes its rows and columns if it is necessary to make the block structure appear.
#'
#' @param  E the observation matrix such that each of its row has a block structure correlation matrix Sigma to estimate up to a permutation of its columns and rows.
#' @param  k numerical or NULL, the rank for the low rank approximation. If NULL the rank is computed using the slope_change function applied on the eigenvalues of the low rank part of Sigma. Default to NULL.
#' @param  nb_nn0 numerical or NULL, corresponds to the number of non null values to keep in the estimation of the covariance matrix.
#' If NULL the number of non null values is computed using the slope_change function to the Frobenius norm of the difference between the empirical correlation matrix and its estimation with nb_nn0 non null values. Default to NULL.
#' @param  method_k character if "Cattell" (the default) then the Cattell criterion \insertCite{cattell1966}{BlockCov} is performed on the singular values of the covariance matrix.
#' to estimate the number of rank use in the low rank approximation, while "PA" use the parrallel analysis \insertCite{Horn1965}{BlockCov}
#' wich can be more accurate if the number of rows of E is not to small but which is much slower.
#' @param times numeric the number of resampling done for the "PA" method, ignored if metod_k is different from "PA".
#' @param  method_0 character if "Elbow" (the default) then the Elbow criterion (see \insertCite{blc;textual}{BlockCov} for details) is performed
#'   to estimate the number of rank use in the low rank approximation, while "BL" use the approach proposed in
#'   \insertCite{bickel2008;textual}{BlockCov} based on cross-validation
#'    wich can be more accurate if the number of rows of E is not to small but which is much slower.
#' @param N numeric the number of fold used for the "BL" method. Ignored if method_0 is different from "BL"
#' @param  big logical, default to FALSE. If the dataset is too big the empirical correlation is calculated by crossprod(E) * 1 / n to fasten the computation
#' @param  reorder logical, default to FALSE. Whether or not the columns of E are permuted. If TRUE a hierarchical clustering is first performed and the columns are permuted according to it.
#' @param  inv_12 logical, default to FALSE Whether or not computing the square root of the inverse of the covariance matrix.
#' @return A list with the elements
#' \item{Sigma_est}{estimator of the covariance matrix}
#' \item{k}{rank of the low rank part of the covariance matrix}
#' \item{nb_nn0}{number of non null values of the upper triangular part of the covariance matrix}
#' \item{S_inv_12}{square root of the inverse of the estimated covariance matrix}
#' \item{order}{permutation to apply to the rows and the columns of the covariance to make the block structure appear}
#' @importFrom Matrix Matrix nearPD t image
#' @importFrom stats cor dist hclust runif
#' @importFrom BBmisc which.last
#'@importFrom Rdpack reprompt
#'@importFrom stats as.dist
#'@importFrom dplyr desc
#'@importFrom dplyr n
#' @examples
#' n <- 30
#' q <- 100
#' Sigma <- Simu_Sigma(q = q, diag = FALSE, equal = TRUE)
#' Matrix::image(Sigma)
#' E <- matrix(rnorm(n * q), ncol = q) %*% chol(as.matrix(Sigma))
#' res <- Sigma_estimation(E, inv_12 = TRUE)
#' Matrix::image(res$Sigma_est)
#' Matrix::image(res$S_inv_12)
#'@references
#'\insertAllCited{}
#' @export
Sigma_estimation <- function(E, k = NULL,
                             nb_nn0 = NULL,
                             big = FALSE, reorder = FALSE,
                             inv_12 = FALSE,
                             method_k = "Cattell",
                             times =10,
                             method_0="Elbow",
                             N=10) {
  ord <- NULL
  q <- ncol(E)
  n <- nrow(E)
  if (!big) {
    corE <- cor(as.matrix(E))
  } else {
    corE <- crossprod(E) * 1 / n
  }

  if (reorder) {
    clust <- hclust(as.dist(1 - corE))
    ord <- clust$order
    E <- E[, ord]
    if (!big) {
      corE <- cor(as.matrix(E))
    } else {
      corE <- crossprod(E) * 1 / n
    }
  }

  vec_up_emp <- corE[upper.tri(corE)]

  Pti_sig <- Matrix(0, ncol = (q - 1), nrow = (q - 1))
  Pti_sig[upper.tri(Pti_sig, diag = TRUE)] <- vec_up_emp
  Pti_sig[lower.tri(Pti_sig)] <- t(as.matrix(Pti_sig))[lower.tri(t(as.matrix(Pti_sig)))]


  res_svd <- svd(Pti_sig)
  vp <- res_svd$d
  u <- res_svd$u
  tv <- t(res_svd$v)

  if (is.null(k)){
    if(method_k =="Cattell")  k <- max(slope_change(vp), 2)
    if(method_k =="PA")  k <- which.last(vp > max(PA(E, times)))
  }
  large_vp <- vp[1:k]
  corE_aprx <- u[, 1:k] %*% diag(large_vp) %*% tv[1:k, ]
  vec_up <- corE_aprx[upper.tri(corE_aprx, diag = TRUE)]
  l <- length(vec_up)
  a_vup <- abs(vec_up)
  ord_vup <- order(a_vup)
  v_ord <- a_vup[ord_vup]

  if (is.null(nb_nn0)) {

    if(method_0 =="Elbow"){
    error <- c(0,cumsum(v_ord^2))
    nb_nn0 <- slope_change(rev(error))
    }
    if(method_0 == "BL"){
  nb_nn0 <- cv_bl(E, v_ord, N=N)
    }
  }
  seuil <- rev(v_ord)[nb_nn0]
  vec_up[a_vup < seuil] <- 0
  Sig_est <- Matrix(0, q, q)
  Sig_est[upper.tri(Sig_est)] <- vec_up
  Sig_est <- Sig_est + t(Sig_est)
  diag(Sig_est) <- 1


  if (reorder) {
    reord <- order(ord)
    Sig_est <- Sig_est[reord, reord]
  }
  Sig_est <- nearPD(Sig_est, corr = TRUE)$mat


  if (inv_12) {
    res_svd <- svd(Sig_est)
    vp2 <- res_svd$d
    u <- res_svd$u
    tv <- t(res_svd$v)

    sel <- which(vp2 > 0.1)
    vp[-sel] <- 0
    S_inv_12 <- u[, sel] %*% diag(sqrt(1 / vp2[sel])) %*% tv[sel, ]
  } else {
    S_inv_12 <- NULL
  }
  return(list(Sigma_est = Sig_est, k = k, nb_nn0 = nb_nn0,
              S_inv_12 = S_inv_12, order = ord))
}

#' Title
#'
#' @param E the observation matrix such that each of its row has a block structure correlation matrix Sigma to estimate up to a permutation of its columns and rows.
#' @param v_ord the absolute value of the upper  triangular part matrix \eqn{\Gamma} (including its diagonal) order in
#' increasing order
#' @param N number of replication in the "cross-validation"
#'
#' @return  the number of non null values selected for the estimation of the covariance matrix
#' @details In order to get the treshold one must do rev(v_ord)[cv_bl(E, v_ord, N=N)]
#' @export
#'
#' @examples
#' n <- 30
#' q <- 100
#' Sigma <- Simu_Sigma(q = q, diag = FALSE, equal = TRUE)
#' Matrix::image(Sigma)
#' E <- matrix(rnorm(n * q), ncol = q) %*% chol(as.matrix(Sigma))
#' k <- 5
#' v_up <- est_up(E, k = k)
#' a_vup <- abs(v_up)
#' ord_vup <- order(a_vup)
#' v_ord <- a_vup[ord_vup]
#' N <- 10
#' nb_nn0 <- cv_bl(E, v_ord, N=N)
#' tresh <- rev(v_ord)[nb_nn0]

cv_bl<- function(E, v_ord, N){
  n <- nrow(E)
  n1 <- round(n*(1- 1/log(n)))

  r_hat <- lapply(1:N, function(i){
    s1 <- sample(seq_len(n), n1)
    s2 <- seq_len(n)[-s1]
    v1 <- est_up(E[s1, ])
    v2 <- est_up(E[s2, ])
    ord <- order(abs(v1))
    v1 <- v1[ord]
    v2 <- v2[ord]
    dif <- (v1 - v2)^2
    ajout <- v2^2 - dif
    fin <- c(sum(dif), ajout)
    r_hat <- cumsum(fin)
    reord <- findInterval(v_ord, abs(v1), left.open = TRUE)
    r_hat[c((reord + 1))]
  })
  r_hat_mean <- Reduce("+", r_hat)
  v_ord[which.min(r_hat_mean)]
  which.min(rev(r_hat_mean))
}



#' Title
#'
#' @param E the observation matrix such that each of its row has a block structure correlation matrix Sigma wich has a low rank once its diagonal is removed.
#' @param times number of random sampling
#'
#' @return the mean of the eigen values of the \code{times} sampled matrix
#' @export
#'
#' @examples
#' n <- 30
#' q <- 100
#' Sigma <- Simu_Sigma(q = q, diag = FALSE, equal = TRUE)
#' Matrix::image(Sigma)
#' E <- matrix(rnorm(n * q), ncol = q) %*% chol(as.matrix(Sigma))
#' random_eigen <- PA(E, times = 10)
PA <- function(E, times = 10){
  q<-ncol(E)
  Reduce("+",  lapply(1:times, function(lalala){
    corEs <- cor(as.matrix(apply(E,2,sample)))
    Pti_sigs <- Matrix(0, ncol = (q - 1), nrow = (q - 1))
    Pti_sigs[upper.tri(Pti_sigs, diag = TRUE)] <- corEs[upper.tri(corEs)]
    Pti_sigs[lower.tri(Pti_sigs)] <- t(as.matrix(Pti_sigs))[lower.tri(t(as.matrix(Pti_sigs)))]
    res_svd_corE <- svd(as.matrix(Pti_sigs))
    res_svd_corE$d
  })) / times
}

#' Title
#'
#' @param E the observation matrix such that each of its row has a block structure correlation matrix Sigma wich has a low rank once its diagonal is removed.
#' @param k the rank of the correlation matrix of \code{E} once its diagonal has been removed
#'
#' @return an approximation of the correlation matrix of \code{E} with its diagonal removed
#' @export
#'
#' @examples
#' n <- 30
#' q <- 100
#' Sigma <- Simu_Sigma(q = q, diag = FALSE, equal = TRUE)
#' Matrix::image(Sigma)
#' E <- matrix(rnorm(n * q), ncol = q) %*% chol(as.matrix(Sigma))
#' k <- 5
#' v_up <- est_up(E, k = k)
est_up <- function(E, k = 5){
  q <- ncol(E)
  corE <- cor(as.matrix(E))
  Pti_sig <- Matrix(0, ncol = (q - 1), nrow = (q - 1))
  Pti_sig[upper.tri(Pti_sig, diag = TRUE)] <- corE[upper.tri(corE)]
  Pti_sig[lower.tri(Pti_sig)] <- t(as.matrix(Pti_sig))[lower.tri(t(as.matrix(Pti_sig)))]
  res_svd_corE <- svd(as.matrix(Pti_sig), nu =k, nv=k)
  vp_corE <- res_svd_corE$d
  U_corE <- res_svd_corE$u
  tV_corE <- t(res_svd_corE$v)
  largest_vp_corE <- vp_corE[1:k]
  corE_aprx <- U_corE[, 1:k] %*% diag(largest_vp_corE) %*% tV_corE[1:k, ]
  return(corE_aprx [upper.tri(corE_aprx)])
}

#' This function generates a block structured symmetric positive definite matrix to test the BlockCov methodology.
#'
#' @param  q integer corresponding to the size of the covariance matrix.
#' @param  diag logical, whether or not the covariance matrix is block-diagonal.
#' @param  equal logical, whether or not the values in the blocks are equal.
#' @return Sigma a correlation matrix to test the BlockCov methodology.
#' @importFrom Matrix Matrix
#' @examples
#' Sigma <- Simu_Sigma(q = 100, diag = FALSE, equal = TRUE)
#' Matrix::image(Sigma)
#' @export
Simu_Sigma <- function(q, diag = TRUE, equal = TRUE) {
  list_a <- c(floor(0.1 * q), floor(0.2 * q), floor(0.3 * q), floor(0.2 * q), floor(0.2 * q))
  list_rho <- c(0.7, 0.75, 0.65, 0.8, 0.7)

  nb_bloc <- length(list_a)
  position <- cumsum(list_a)
  Z <- Matrix(0, nrow = q, ncol = nb_bloc)
  if (equal) {
    Z[1:position[1], 1] <- rep(sqrt(list_rho[1]), list_a[1])
    for (i in 2:nb_bloc) {
      Z[(position[(i - 1)] + 1):position[i], i] <- rep(sqrt(list_rho[i]), list_a[i])
    }
  } else {
    Z[1:position[1], 1] <- runif(list_a[1], sqrt(0.6), sqrt(0.8))
    for (i in 2:nb_bloc) {
      if (i == 3) {
        Z[(position[(i - 1)] + 1):position[i], i] <- runif(list_a[i], sqrt(0.3), sqrt(0.4))
      } else {
        Z[(position[(i - 1)] + 1):position[i], i] <- runif(list_a[i], sqrt(0.6), sqrt(0.8))
      }
    }
  }

  if (!diag) Z[floor(0.35 * q):floor(0.45 * q), 4] <- -0.5
  Sigma <- Z %*% t(Z)
  diag(Sigma) <- 1
  return(Sigma)
}

#' This function fits to a numerical vector sorted in the non decreasing order two simple linear regressions and returns the index corresponding to the estimated change between the two regression models.
#'
#' @param  Y numerical vector sorted in the non decreasing order.
#' @return K the index corresponding to the estimated change between the two linear regression models.
#' @importFrom Matrix Matrix
#' @importFrom dplyr arrange filter mutate cummean
#' @importFrom tibble tibble rowid_to_column
#' @importFrom rlang .data
#' @examples
#' n <- 30
#' q <- 100
#' Sigma <- Simu_Sigma(q = q, diag = FALSE, equal = TRUE)
#' Matrix::image(Sigma)
#' E <- matrix(rnorm(n * q), ncol = q) %*% chol(as.matrix(Sigma))
#' corE <- cor(as.matrix(E))
#' vec_up_emp <- corE[upper.tri(corE)]
#' G <- matrix(0, ncol = (q - 1), nrow = (q - 1))
#' G[upper.tri(G, diag = TRUE)] <- vec_up_emp
#' G[lower.tri(G)] <- t(as.matrix(G))[lower.tri(t(as.matrix(G)))]
#' res_svd <- svd(G)
#' vp <- res_svd$d
#' slope_change(vp)
#' @export
slope_change <- function(Y) {
  tb <- tibble(y = Y) %>%
    arrange(desc(.data$y)) %>%
    rowid_to_column(var = "x") %>%
    mutate(
      mx = (.data$x + 1) / 2,
      my = cummean(.data$y),
      pxy = .data$x * .data$y,
      spxy = cumsum(.data$pxy),
      s2xy = .data$spxy - .data$mx * .data$x * .data$my,
      s2x = (.data$x * (.data$x + 1) * (.data$x - 1)) / 12,
      b = .data$s2xy / .data$s2x,
      a = .data$my - .data$b * .data$mx,
      y2 = cumsum(.data$y^2),
      e = .data$y2 + (.data$b^2 * (.data$x * (.data$x + 1) *
                                     (2 * .data$x + 1)) / 6) +
        2 * .data$a * .data$b * .data$x * .data$mx +
        .data$x * .data$a^2 -
        2 * .data$b * .data$spxy - 2 * .data$a * .data$my * .data$x
    ) %>%
    filter(.data$x != n())

  n <- length(Y)
  tb2 <- tibble(y = Y) %>%
    arrange(desc(.data$y)) %>%
    rowid_to_column(var = "x") %>%
    arrange(.data$y) %>%
    rowid_to_column(var = "k") %>%
    mutate(
      mx = (.data$x + n) / 2,
      my = cummean(.data$y),
      pxy = .data$x * .data$y,
      spxy = cumsum(.data$pxy),
      s2xy = .data$spxy - .data$mx * .data$k * .data$my,
      s2xi = (n * (n + 1) * (2 * n + 1) - .data$x * (.data$x - 1) *
                (2 * .data$x - 1)) / 6,
      s2x = .data$s2xi - .data$k * (n + .data$x)^2 / 4,
      b = .data$s2xy / .data$s2x,
      a = .data$my - .data$b * .data$mx,
      y2 = cumsum(.data$y^2),
      e = .data$y2 + (.data$b^2 * .data$s2xi) +
        2 * .data$a * .data$b * .data$k * .data$mx + .data$k * .data$a^2 -
        2 * .data$b * .data$spxy - 2 * .data$a * .data$my * .data$k
    ) %>%
    filter(.data$x != n())
  errors <- tb$e + rev(tb2$e)
  which.min(errors) - 1
}

#' \code{BlockCov} package
#'
#' Estimation of Large Block Covariance Matrices
#'
#' See the README on
#' \href{https://cran.r-project.org/package=BlockCov/vignettes/Vignettes.pdf}{CRAN}
#'\href{https://github.com/Marie-PerrotDockes/BlockCov#readme}{GitHub}
#'
#' @docType package
#' @name BlockCov
NULL

---
title: "BlockCov package"
author: "Marie Perrot-Dockès, Céline Lévy-Leduc"
date: "`r Sys.Date()`"
output: pdf_document
vignette: >
  %\VignetteEngine{knitr::knitr}
  %\VignetteIndexEntry{BlockCov package}
  %VignetteEncoding{UTF-8}
bibliography: REFERENCES.bib
---

```{r setup, include=FALSE}
knitr::opts_chunk$set(echo = TRUE, message=FALSE)
library(BlockCov)
set.seed(516)
```

# Installation 

```{r, , eval =FALSE}
devtools::install_github("Marie-PerrotDockes/BlockCov")
```


# Introduction

This package implements the algorithm proposed by @blc. For further details we refer the reader to this paper.
We shall consider the following framework. Let  $\boldsymbol{E}_1, \boldsymbol{E}_2,\cdots,\boldsymbol{E}_n$, $n$ zero-mean i.i.d. $q$-dimensional 
random vectors having a covariance matrix 
$\boldsymbol{\Sigma}$ such that the number $q$ of its rows and columns is much larger than $n$. 
The goal of the package is to propose a new estimator of $\boldsymbol{\Sigma}$ and of the square root of its inverse in the particular case 
where $\boldsymbol{\Sigma}$ is assumed to have a block structure without limiting ourselves to diagonal blocks.
More precisely, in this paper, we shall assume that

$$
\boldsymbol{\Sigma}=\boldsymbol{Z}\;\boldsymbol{Z}'+\boldsymbol{D},
$$

where $\boldsymbol{Z}$ is a $q \times k$ sparse matrix with $k\ll q$, $\boldsymbol{Z}'$ denotes the transpose of the matrix $\boldsymbol{Z}$ and $\boldsymbol{D}$
is a diagonal matrix such that the diagonal terms of $\boldsymbol{\Sigma}$ are equal to one.

Our approach consists in providing a low rank matrix approximation of the $\boldsymbol{Z}\;\boldsymbol{Z}'$ part of
$\boldsymbol{\Sigma}$ and then in using a $\ell_1$ regularization in order to obtain a sparse estimator of $\boldsymbol{\Sigma}$.
More precisely, since $\boldsymbol{\Sigma}$ is a correlation matrix, it is a symmetric matrix with ones on its diagonal, thus all the information is contained in its upper triangular part without its diagonal. If we know $\boldsymbol{P}$ the $(q-1)\times (q-1)$ symmetric matrix, which has for upper triangular part the upper triangular part of $\boldsymbol{\Sigma}$ without its diagonal, we know $\boldsymbol{\Sigma}$. The matrix $\boldsymbol{P}$ has the advantage to have a low rank. In the following, we propose to first estimate the block matrix $\boldsymbol{P}$. 

We shall moreover propose a methodology to estimate $\boldsymbol{\Sigma}$ in the case where the block structure is latent that is when the columns and rows of $\boldsymbol{\Sigma}$ have
to be permuted according to an unknown permutation in order to make the block structure appear. In this case, a hierarchical clustering step has to be applied beforehand.

# Simulation of $\boldsymbol{\Sigma}$ having a block structure

In order to generate a matrix $\boldsymbol{\Sigma}$ having a block structure with extra-diagonal blocks and $q=100$,
we can use the function `|Simu_Sigma|` as follows:

```{r}
q <- 100
Sigma <- Simu_Sigma(q = q, diag = FALSE, equal = TRUE)
```

The matrix $\boldsymbol{\Sigma}$ is displayed in Figure \ref{fig:fig0}.

```{r fig0, fig.cap="\\label{fig:fig0}",fig.width=3.5,fig.height=3.5,echo=FALSE}
Matrix::image(Sigma)
```


Using the matrix $\boldsymbol{\Sigma}$ generated by the function `|Simu_Sigma|` a $n\times q$ matrix $\boldsymbol{E}$ was generated such that its rows are independent zero-mean Gaussian random vectors having a covariance matrix equal to $\boldsymbol{\Sigma}$ and $n=30$.
 
```{r}
n <- 30
E <- matrix(rnorm(n * q), ncol = q) %*% chol(as.matrix(Sigma))
```

#  Estimation of $\boldsymbol{\Sigma}$ (without estimating and $\boldsymbol{\Sigma}^{-1/2}$)

## Estimation of $\boldsymbol{\Sigma}$ when the parameters are known

In order to get an estimator of $\boldsymbol{\Sigma}$ the function `|Sigma_estimation|` was applied. Since the data set was simulated, the rank of $\boldsymbol{P}$, the sub-matrix of $\boldsymbol{\Sigma}$, and its number of non null values are known. 

```{r}
k <- 5
nb_nn0 <- sum(Sigma[upper.tri(Sigma, diag = FALSE)] != 0)
res_known <-  Sigma_estimation(E, k = k, nb_nn0 = nb_nn0)
```

Our estimator $$\widehat{\boldsymbol{\Sigma}}$$ of $\boldsymbol{\Sigma}$ is given by `|res_known$Sigma_est|`.
It is displayed in Figure \ref{fig:fig1} and is obtained by using:

```{r fig1, fig.cap="\\label{fig:fig1}",fig.width=3.5,fig.height=3.5}
Matrix::image(res_known$Sigma_est)
```

The Frobenius norm $\|\boldsymbol{\Sigma}-\widehat{\boldsymbol{\Sigma}}\|$ is equal to `r round(norm(as.matrix(Sigma-res_known$Sigma_est), 'F'), 1)`. 

For comparison purpose, the sample correlation matrix is displayed in Figure \ref{fig:fig2}.

```{r fig2, fig.cap="\\label{fig:fig2}",fig.width=3.5,fig.height=3.5}
Matrix::image(Matrix::Matrix(cor(E)))
```

The Frobenius norm $\|\boldsymbol{\Sigma}-\widehat{\boldsymbol{\Sigma}}_{\textrm{emp}}\|$ is equal to `r round(norm(as.matrix(Sigma-cor(E)), 'F'), 1)`, where $\widehat{\boldsymbol{\Sigma}}_{\textrm{emp}}$ denotes the sample correlation matrix.

## Estimation of $\boldsymbol{\Sigma}$ when the parameters are unknown

In practice, the number of non null values and the rank of $\boldsymbol{P}$ are unknown. 
These parameters can be both estimated using the function `|Sigma_estimation|`.

For choosing the rank of $\boldsymbol{P}$,  two strategies are available in the package and compared in  @blc: 

  * The first strategy is the \textsf{Cattell} criterion based on the Cattell's scree plot described in @cattell1966. In the package, it can be used by setting \verb|method_k = "Cattell"| in the                \verb|Sigma_estimation| function.
  * The second strategy is the \textsf{PA} permutation method proposed by @Horn1965. In the package, it can be used by setting \verb|method_k = "PA"| in  the \verb|Sigma_estimation| function.


To choose the number of non null values two methodologies are also available in the package and compared in  @blc: 

  * The \textsf{Elbow} method described in @blc. In the package, it can be used by setting \verb|method_0 = "Elbow"| in  \verb|Sigma_estimation| function and
  * the \textsf{BL} approach proposed in @bickel2008 based on cross-validation. In the package, it can be used by setting \verb|method_0 = "BL"| in  the \verb|Sigma_estimation| function.


For example, an estimator of $\boldsymbol{\Sigma}$ using the \textsf{Cattell} criterion and the \textsf{Elbow} method can be obtained by using the `|Sigma_estimation|` function as follows:

```{r,warning=FALSE}
res <-Sigma_estimation(E, method_k = "Cattell", method_0 = "Elbow")
```
It has to be noticed that "Cattell" and "Elbow" are the default value for `|method_k|` and `|method_0|` respectively. Hence, the same result can be obtain by using : 

```{r, eval = FALSE}
res <-Sigma_estimation(E)
```

The corresponding estimator of $\boldsymbol{\Sigma}$ is displayed in Figure \ref{fig:fig3}.
The estimated rank and the estimated number of non null values can be obtained by `|res$k|` and `|res$nb_nn0|`, respectively.
Here, the estimated rank is equal to `r res$k`  and the estimated number of non null values is `r res$nb_nn0`. Note that the true values of these parameters are `r res_known$k` and `r res_known$nb_nn0`.

An estimator of $\boldsymbol{\Sigma}$ using  the \textsf{PA} criterion and  the \textsf{BL} method  can be obtained by using the \verb|Sigma_estimation| function as follows:

```{r}
res_pabl <- Sigma_estimation(E, method_k = "PA", method_0 = "BL")
```
The corresponding estimator of $\boldsymbol{\Sigma}$ is displayed in Figure \ref{fig:fig3pabl}.
Here, the estimated rank is equal to `r res_pabl$k`  and the estimated number of non null values is 
`r res_pabl$nb_nn0`.

This second approach is a little bit slower than the first one especially for large values of $q$ but can be more 
accurate when the number of samples is large enough, see @blc for further details on the numerical and statistical performance of the different strategies.


```{r fig3, fig.cap="\\label{fig:fig3}",fig.width=3.5,fig.height=3.5}
Matrix::image(res$Sigma_est)
```

```{r fig3pabl, fig.cap="\\label{fig:fig3pabl}",fig.width=3.5,fig.height=3.5}
Matrix::image(res_pabl$Sigma_est)
```

We can see from this figure that the estimation of $\boldsymbol{\Sigma}$ does not seem to be altered by 
having to estimate the number of non null values and the rank of the matrix. The Frobenius norm $\|\boldsymbol{\Sigma}-\widehat{\boldsymbol{\Sigma}}\|$ is equal to `r round(norm(as.matrix(Sigma-res$Sigma_est), 'F'), 1)` for the first estimator and to `r round(norm(as.matrix(Sigma-res_pabl$Sigma_est), 'F'), 1)` for the second one.

# Estimator of $\boldsymbol{\Sigma}^{-1/2}$ obtained from an estimator of $\boldsymbol{\Sigma}$

An estimator of $\boldsymbol{\Sigma}^{-1/2}$ can be obtained using the \verb|Sigma_estimation| function by setting the arguments \verb|res$S_inv_12| to true as follows: 

```{r}
res_both <- Sigma_estimation(E, method_k = "Cattell", method_0 = "Elbow", inv_12 = TRUE)
```

An estimator of $\boldsymbol{\Sigma}$ is obtained with \verb|res_both$Sigma_est| and an estimator of $\boldsymbol{\Sigma}^{-1/2}$ is obtained with \verb|res_both$S_inv_12|.
It can be used to remove the dependence that may exist between the columns of $\boldsymbol{E}$.


#  Estimation of $\boldsymbol{\Sigma}$ and $\boldsymbol{\Sigma}^{-1/2}$ when the block structure is latent

In practice, it is possible that the block structure of $\boldsymbol{\Sigma}$ only appears after having permuted its rows and columns according to a well chosen permutation. We explain hereafter how to estimate $\boldsymbol{\Sigma}$ and $\boldsymbol{\Sigma}^{-1/2}$ in this case.
We first generate such a matrix by applying a random permutation to the rows and columns of the matrix $\boldsymbol{\Sigma}$ previously generated.

```{r}
samp <- sample(1:q, q, replace = FALSE)
Sigma_samp <- Sigma[samp, samp]
```

The corresponding matrix is displayed in Figure \ref{fig:fig4}.

```{r fig4, fig.cap="\\label{fig:fig4}",fig.width=3.5,fig.height=3.5}
Matrix::image(Sigma_samp)
```

In such a situation where the columns and rows have to be permuted according to an unknown permutation, we propose to use a hierarchical clustering as the first step of our methodology and then use the same strategy. This is performed by putting \verb|reorder=TRUE| in the arguments of the function \verb|Sigma_estimation|.

```{r}
E <- matrix(rnorm(n * q), ncol = q) %*% chol(as.matrix(Sigma_samp))
res_samp <- Sigma_estimation(E, reorder = TRUE, inv_12 = TRUE)
```

The estimated matrix is displayed in Figure \ref{fig:fig5}.

```{r fig5, fig.cap="\\label{fig:fig5}",fig.width=3.5,fig.height=3.5}
Matrix::image(res_samp$Sigma_est)
```

The permutation to make the block structure appear is available from \verb|res_samp$order|. 
The corresponding estimated correlation matrix in which the columns have been permuted in order to make
the block structure appear is obtained using the following lines and is displayed in Figure \ref{fig:fig6}:

```{r fig6, fig.cap="\\label{fig:fig6}",fig.width=3.5,fig.height=3.5}
ord <- res_samp$order
Matrix::image(res_samp$Sigma_est[ord, ord])
```

This matrix has to be compared with the following one displayed in Figure \ref{fig:fig7}:

```{r fig7, fig.cap="\\label{fig:fig7}",fig.width=3.5,fig.height=3.5}
Matrix::image(Sigma_samp[ord, ord])
```

Once again, our strategy does not seem to be altered by the permutation of the columns of the original matrix $\boldsymbol{\Sigma}$.
The Frobenius norm of the error is equal to `r round(norm(as.matrix(Sigma_samp-res_samp$Sigma_est), 'F'), 1)`.

In this situation $\widehat{\boldsymbol{\Sigma}}^{-1/2}$ is still available. The matrix
$\widehat{\boldsymbol{\Sigma}}^{-1/2}\boldsymbol{\Sigma}\widehat{\boldsymbol{\Sigma}}^{-1/2}$, which is displayed in Figure \ref{fig:fig8},
should be close to the identity matrix: 

```{r fig8, fig.cap="\\label{fig:fig8}",fig.width=3.5,fig.height=3.5}
Matrix::image(res_samp$S_inv_12 %*% Sigma_samp %*%res_samp$S_inv_12)
```

The associated Frobenius norm $||\widehat{\boldsymbol{\Sigma}}^{-1/2}\boldsymbol{\Sigma}\widehat{\boldsymbol{\Sigma}}^{-1/2}-\textrm{Id}_q||=$ 
`r round(norm(as.matrix(res_samp$S_inv_12%*%Sigma_samp%*%t(res_samp$S_inv_12)- diag(1,q))),1)`.


All the values of the Frobenius norms are quite close meaning that our methodology  is efficient even when the parameters are unknown and when the columns and rows have to be permuted in order to make the block structure appear.


# References

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/slope_change.R
\name{slope_change}
\alias{slope_change}
\title{This function fits to a numerical vector sorted in the non decreasing order two simple linear regressions and returns the index corresponding to the estimated change between the two regression models.}
\usage{
slope_change(Y)
}
\arguments{
\item{Y}{numerical vector sorted in the non decreasing order.}
}
\value{
K the index corresponding to the estimated change between the two linear regression models.
}
\description{
This function fits to a numerical vector sorted in the non decreasing order two simple linear regressions and returns the index corresponding to the estimated change between the two regression models.
}
\examples{
n <- 30
q <- 100
Sigma <- Simu_Sigma(q = q, diag = FALSE, equal = TRUE)
Matrix::image(Sigma)
E <- matrix(rnorm(n * q), ncol = q) \%*\% chol(as.matrix(Sigma))
corE <- cor(as.matrix(E))
vec_up_emp <- corE[upper.tri(corE)]
G <- matrix(0, ncol = (q - 1), nrow = (q - 1))
G[upper.tri(G, diag = TRUE)] <- vec_up_emp
G[lower.tri(G)] <- t(as.matrix(G))[lower.tri(t(as.matrix(G)))]
res_svd <- svd(G)
vp <- res_svd$d
slope_change(vp)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/cv_pa.R
\name{cv_bl}
\alias{cv_bl}
\title{Title}
\usage{
cv_bl(E, v_ord, N)
}
\arguments{
\item{E}{the observation matrix such that each of its row has a block structure correlation matrix Sigma to estimate up to a permutation of its columns and rows.}

\item{v_ord}{the absolute value of the upper  triangular part matrix \eqn{\Gamma} (including its diagonal) order in
increasing order}

\item{N}{number of replication in the "cross-validation"}
}
\value{
the number of non null values selected for the estimation of the covariance matrix
}
\description{
Title
}
\details{
In order to get the treshold one must do rev(v_ord)[cv_bl(E, v_ord, N=N)]
}
\examples{
n <- 30
q <- 100
Sigma <- Simu_Sigma(q = q, diag = FALSE, equal = TRUE)
Matrix::image(Sigma)
E <- matrix(rnorm(n * q), ncol = q) \%*\% chol(as.matrix(Sigma))
k <- 5
v_up <- est_up(E, k = k)
a_vup <- abs(v_up)
ord_vup <- order(a_vup)
v_ord <- a_vup[ord_vup]
N <- 10
nb_nn0 <- cv_bl(E, v_ord, N=N)
tresh <- rev(v_ord)[nb_nn0]
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/cv_pa.R
\name{PA}
\alias{PA}
\title{Title}
\usage{
PA(E, times = 10)
}
\arguments{
\item{E}{the observation matrix such that each of its row has a block structure correlation matrix Sigma wich has a low rank once its diagonal is removed.}

\item{times}{number of random sampling}
}
\value{
the mean of the eigen values of the \code{times} sampled matrix
}
\description{
Title
}
\examples{
n <- 30
q <- 100
Sigma <- Simu_Sigma(q = q, diag = FALSE, equal = TRUE)
Matrix::image(Sigma)
E <- matrix(rnorm(n * q), ncol = q) \%*\% chol(as.matrix(Sigma))
random_eigen <- PA(E, times = 10)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Sigma_estimation.R
\name{Sigma_estimation}
\alias{Sigma_estimation}
\title{This function computes an estimator of the covariance matrix and the square root of its inverse and permutes its rows and columns if it is necessary to make the block structure appear.}
\usage{
Sigma_estimation(E, k = NULL, nb_nn0 = NULL, big = FALSE,
  reorder = FALSE, inv_12 = FALSE, method_k = "Cattell",
  times = 10, method_0 = "Elbow", N = 10)
}
\arguments{
\item{E}{the observation matrix such that each of its row has a block structure correlation matrix Sigma to estimate up to a permutation of its columns and rows.}

\item{k}{numerical or NULL, the rank for the low rank approximation. If NULL the rank is computed using the slope_change function applied on the eigenvalues of the low rank part of Sigma. Default to NULL.}

\item{nb_nn0}{numerical or NULL, corresponds to the number of non null values to keep in the estimation of the covariance matrix.
If NULL the number of non null values is computed using the slope_change function to the Frobenius norm of the difference between the empirical correlation matrix and its estimation with nb_nn0 non null values. Default to NULL.}

\item{big}{logical, default to FALSE. If the dataset is too big the empirical correlation is calculated by crossprod(E) * 1 / n to fasten the computation}

\item{reorder}{logical, default to FALSE. Whether or not the columns of E are permuted. If TRUE a hierarchical clustering is first performed and the columns are permuted according to it.}

\item{inv_12}{logical, default to FALSE Whether or not computing the square root of the inverse of the covariance matrix.}

\item{method_k}{character if "Cattell" (the default) then the Cattell criterion \insertCite{cattell1966}{BlockCov} is performed on the singular values of the covariance matrix.
to estimate the number of rank use in the low rank approximation, while "PA" use the parrallel analysis \insertCite{Horn1965}{BlockCov}
wich can be more accurate if the number of rows of E is not to small but which is much slower.}

\item{times}{numeric the number of resampling done for the "PA" method, ignored if metod_k is different from "PA".}

\item{method_0}{character if "Elbow" (the default) then the Elbow criterion (see \insertCite{blc;textual}{BlockCov} for details) is performed
to estimate the number of rank use in the low rank approximation, while "BL" use the approach proposed in
\insertCite{bickel2008;textual}{BlockCov} based on cross-validation
 wich can be more accurate if the number of rows of E is not to small but which is much slower.}

\item{N}{numeric the number of fold used for the "BL" method. Ignored if method_0 is different from "BL"}
}
\value{
A list with the elements
\item{Sigma_est}{estimator of the covariance matrix}
\item{k}{rank of the low rank part of the covariance matrix}
\item{nb_nn0}{number of non null values of the upper triangular part of the covariance matrix}
\item{S_inv_12}{square root of the inverse of the estimated covariance matrix}
\item{order}{permutation to apply to the rows and the columns of the covariance to make the block structure appear}
}
\description{
This function computes an estimator of the covariance matrix and the square root of its inverse and permutes its rows and columns if it is necessary to make the block structure appear.
}
\examples{
n <- 30
q <- 100
Sigma <- Simu_Sigma(q = q, diag = FALSE, equal = TRUE)
Matrix::image(Sigma)
E <- matrix(rnorm(n * q), ncol = q) \%*\% chol(as.matrix(Sigma))
res <- Sigma_estimation(E, inv_12 = TRUE)
Matrix::image(res$Sigma_est)
Matrix::image(res$S_inv_12)
}
\references{
\insertAllCited{}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/BlockCov.R
\docType{package}
\name{BlockCov}
\alias{BlockCov}
\alias{BlockCov-package}
\title{\code{BlockCov} package}
\description{
Estimation of Large Block Covariance Matrices
}
\details{
See the README on
\href{https://cran.r-project.org/package=BlockCov/vignettes/Vignettes.pdf}{CRAN}
\href{https://github.com/Marie-PerrotDockes/BlockCov#readme}{GitHub}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Simu_Sigma.R
\name{Simu_Sigma}
\alias{Simu_Sigma}
\title{This function generates a block structured symmetric positive definite matrix to test the BlockCov methodology.}
\usage{
Simu_Sigma(q, diag = TRUE, equal = TRUE)
}
\arguments{
\item{q}{integer corresponding to the size of the covariance matrix.}

\item{diag}{logical, whether or not the covariance matrix is block-diagonal.}

\item{equal}{logical, whether or not the values in the blocks are equal.}
}
\value{
Sigma a correlation matrix to test the BlockCov methodology.
}
\description{
This function generates a block structured symmetric positive definite matrix to test the BlockCov methodology.
}
\examples{
Sigma <- Simu_Sigma(q = 100, diag = FALSE, equal = TRUE)
Matrix::image(Sigma)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/cv_pa.R
\name{est_up}
\alias{est_up}
\title{Title}
\usage{
est_up(E, k = 5)
}
\arguments{
\item{E}{the observation matrix such that each of its row has a block structure correlation matrix Sigma wich has a low rank once its diagonal is removed.}

\item{k}{the rank of the correlation matrix of \code{E} once its diagonal has been removed}
}
\value{
an approximation of the correlation matrix of \code{E} with its diagonal removed
}
\description{
Title
}
\examples{
n <- 30
q <- 100
Sigma <- Simu_Sigma(q = q, diag = FALSE, equal = TRUE)
Matrix::image(Sigma)
E <- matrix(rnorm(n * q), ncol = q) \%*\% chol(as.matrix(Sigma))
k <- 5
v_up <- est_up(E, k = k)
}
